var
  B: Byte;

const
  CtrlPort = $67;
  PortB =$65;

begin
  WriteLn('Test Z80 CPU');
  WriteLn('(c) 2015 Martin www.8bity.cz');
  WriteLn;
  Port[CtrlPort]:=$80;   {Zeta 8255 Mode 0 port B OUT}

  inline($3E/$00/     { LD A,0 }
         $D3/PortB);  { OUT (0x65),A  }
  WriteLn('Test Zeta 8255, 0x00 = ',Port[PortB]);

  inline($3E/$FF/     { LD A,0xFF }
         $D3/PortB);  { OUT (0x65),A }
  WriteLn('Test Zeta 8255, 0xFF = ',Port[PortB]);
  WriteLn;

  inline($0E/PortB/   { LD C,0x65 }
         $ED/$71);    { OUT (C),0 - undocumented instruction}
                      { outputs 0 on NMOS and 0xFF on CMOS CPU }
  B:=Port[PortB];
  WriteLn('OUT (C),0 on Zeta 8255 Port B = ',B);
  WriteLn;

  if B=0 then
    begin
      WriteLn('NMOS Z80 CPU detected');
    end
  else
    begin
      WriteLn('CMOS Z80 CPU detected');
    end;
end.
